freeslot ('SPR2_MENU','SPR2_TVBG','SPR2_TELE','SPR2_HEAD')
freeslot("SPR2_JAMP")
freeslot("S_SONKI_JAMP")
freeslot('SPR2_BNES','SPR2_TNES')

//jumpthok
local function mometumjumpthok(p)
	if p.mo.skin == "sonki"
	and not (p.pflags & PF_THOKKED)
	and p.canjumpthokring == true
		P_Thrust(p.mo, p.mo.angle, p.actionspd)
		P_SetObjectMomZ(p.mo, 10*FRACUNIT)
		local jumpthokring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_JUMPTHOKRING)
		jumpthokring.color = p.mo.color
		jumpthokring.angle = p.cmd.angleturn << 16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT) + ANGLE_90
		jumpthokring.scale = p.mo.scale
		jumpthokring.destscale = p.mo.scale
		jumpthokring.tics = 3
		S_StartSound(p.mo, sfx_thok)
		p.canjumpthokring = false
		p.pflags = $|PF_THOKKED
	end
end

addHook("AbilitySpecial", mometumjumpthok)

local function thoktrail(p)
	if p.mo.skin == "sonki"
	and (p.pflags & PF_THOKKED)
		local thoktrail = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
		thoktrail.color = p.mo.color
		thoktrail.fuse = 5
	end
end

addHook("PlayerThink", thoktrail)
	
local function givememyringbackplease(p)
	if p.mo.skin == "sonki"
	and not (p.pflags & PF_THOKKED)
		p.canjumpthokring = true
	end
end

addHook("PlayerThink", givememyringbackplease)

local function thicc(p)
if p.mo.skin == "sonki"
	if p.jt == nil then
		p.jt = 0
		p.jp = false
		p.sp = false
		p.tk = false
		p.tr = false
	end
	if p.jt > 0 then
		p.jt = p.jt - 1
	end
	if p.jt < 0 then
		p.jt = p.jt + 1
	end
	if p.mo.momz < 1 then
		p.jp = false
	end
	if p.mo.state != S_PLAY_CLIMB and p.mo.eflags != p.mo.eflags | MFE_GOOWATER then
		if p.mo.momz > 0 and p.jp == false and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
		if p.mo.momz > 0 and p.jt < 0 and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
	elseif p.mo.eflags == p.mo.eflags | MFE_GOOWATER
		p.jp = true
	end
	if p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.jt = -5
	end
	/*
	if p.pflags != p.pflags | PF_SPINNING or p.pflags == p.pflags | PF_JUMPED then
		p.sp = false
	end
	if p.pflags == p.pflags | PF_SPINNING and p.pflags != p.pflags | PF_JUMPED and p.sp == false and p.jt < 1 then
		p.sp = true
		p.jt = -5
	end
	*/
	if p.pflags != p.pflags | PF_THOKKED then
		p.tk = false
	end
	if p.pflags == p.pflags | PF_THOKKED and p.tk == false then
		p.tk = true
		p.jt = 5
	end
	if p.mo.state != S_PLAY_FLY_TIRED then
		p.tr = false
	end
	if p.mo.state == S_PLAY_FLY_TIRED and p.tr == false then
		p.tr = true
		p.jt = 5
	end
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.mo.spriteyscale = p.maths + FRACUNIT
	
	p.maths = p.jt*p.spinheight
	if p.mo.state != S_PLAY_ROLL then
		p.maths = p.jt*p.height
	end
	p.maths = p.maths / 20
	p.mo.spriteyoffset = -1*p.maths
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.maths = p.maths*-1
	p.mo.spritexscale = p.maths + FRACUNIT
end
end
addHook("PlayerThink", thicc)
local function tailsthink(mo)
	mo.spriteyscale = mo.tracer.spriteyscale
	mo.spritexscale = mo.tracer.spritexscale
	mo.spriteyoffset = mo.tracer.spriteyoffset
end
addHook("MobjThinker", tailsthink, MT_TAILSOVERLAY)

-- By Sls64LGamingBro
-- Enjoy the Mod!


addHook("PlayerThink", function(player)
	if (player.mo.skin == "sonki")
	and (player.pflags & PF_THOKKED)
		local thoktrail = P_SpawnGhostMobj(player.mo)
		thoktrail.fuse = 7
		thoktrail.state = S_THOK
		thoktrail.scalespeed = FRACUNIT/15
		thoktrail.destscale = 0
		thoktrail.frame = TR_TRANS80|A
		thoktrail.frame = $ & ~FF_TRANSMASK | TR_TRANS30	
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.state == S_PLAY_SPINDASH)
		and (player.mo.skin == "sonki")
		local spindashcharge = P_SpawnGhostMobj(player.mo)
		spindashcharge.fuse = 10
		spindashcharge.blendmode = AST_ADD
		spindashcharge.color = player.mo.color
		spindashcharge.colorized = true
	end
end)


addHook("PlayerThink", function(player)
	if (player.powers[pw_super])
		and (player.mo.skin == "sonki")
		local supertrail = P_SpawnGhostMobj(player.mo)
		supertrail.fuse = 13
		supertrail.blendmode = AST_ADD
		supertrail.color = player.mo.color
		supertrail.colorized = true
	end
end)

addHook("PlayerThink", function(player)
	if (player.powers[pw_invulnerability])
		and (player.mo.skin == "sonki")
		local sparkletrail = P_SpawnGhostMobj(player.mo)
		sparkletrail.fuse = 19
		sparkletrail.blendmode = AST_ADD
		sparkletrail.color = player.mo.color
		sparkletrail.colorized = true
	end
end)

freeslot("sfx_boin")

sfxinfo[sfx_boin].caption = "Bounce"

//taken from the pins of the srb2 offical server scipting channel thanks tasurtu
local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end


addHook("SpinSpecial", function(player)
		if player.mo.skin == "sonki"
		and (player.mo.state == S_PLAY_JUMP)
		and not (player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_ELEMENTAL or player.powers[pw_shield] == SH_BUBBLEWRAP or player.powers[pw_shield] == SH_FORCE or player.powers[pw_shield] == SH_ATTRACT or player.powers[pw_shield] == SH_THUNDERCOIN or player.powers[pw_shield] == SH_FLAMEAURA or player.powers[pw_shield] == SH_ARMAGEDDON)
		and not (player.pflags & PF_USEDOWN)
		player.bouncing = true
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.bouncing == true
		player.mo.state = S_PLAY_BOUNCE
	end
	if player.bouncing == true
	and not (player.powers[pw_justsprung] or player.mo.eflags & MFE_SPRUNG or player.mo.eflags & MFE_GOOWATER)
		P_SetObjectMomZ(player.mo, -40*FRACUNIT)
	end
	if player.bouncing
	and (player.mo.eflags & MFE_GOOWATER)
		player.bouncing = false
		player.mo.state = S_PLAY_FALL
	end
end)
						
addHook("PlayerThink", function(p)
	if p.mo.skin == "sonki"
	and p.bouncing
	and (p.mo.eflags & MFE_JUSTHITFLOOR)
	and not (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
		CheckAndCrumble(p.mo, p.mo.subsector.sector)
		local stj = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPRINGTRICKRING)
		stj.color = p.mo.color
		stj.scale = p.mo.scale
		stj.destscale = p.mo.scale
		stj.tics = 3
		stj.renderflags = stj.renderflags|RF_FLOORSPRITE|FF_FULLBRIGHT
		stj.blendmode = AST_ADD
		P_SetObjectMomZ(p.mo, 14*FRACUNIT)
		S_StartSound(p.mo, sfx_boin)
		p.mo.state = S_PLAY_JUMP
		p.pflags = $|PF_JUMPED
		p.bouncing = false
	end
	if (p.pflags & PF_JUMPED)
		p.pflags = $ & ~PF_SPINNING
	end
end)


addHook("PlayerThink", function(p)
	if p.mo.skin == "sonki"
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and (p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_FALL)
		p.springed = true
	elseif P_IsObjectOnGround(p.mo)
		p.springed = false
	end
	if p.bouncing 
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and not p.powers[pw_underwater]
		p.bouncing = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end
	if p.bouncing 
	and (p.powers[pw_justsprung] or p.mo.eflags & MFE_SPRUNG)
	and p.powers[pw_underwater]
		p.bouncing = false
		S_StopSoundByID(p.mo, sfx_spring)
		S_StartSound(p.mo, sfx_sprong)
		p.mo.momz = $*5/4
	end
end)

//cool code by sls
addHook("PlayerThink", function(player)
    if (player.mo.skin == "sonki")
    and (player.pflags & PF_THOKKED)
         S_StartSound(player.mo, sfx_fire)
         local fire = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(0, 50) * FRACUNIT, MT_FIREBALLTRAIL)
         fire.color = SKINCOLOR_SAPPHIRE
         fire.colorized = true
         fire.scale =  1*FRACUNIT/2
         fire.destscale =  1*FRACUNIT/4
         fire.momz = 2*FRACUNIT
         local puma = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(0, 50) * FRACUNIT, MT_PUMATRAIL)
         puma.color = SKINCOLOR_ICY
         puma.colorized = true
         puma.scale =  1*FRACUNIT/2
         puma.destscale =  1*FRACUNIT/4
         puma.momz = 2*FRACUNIT
    end
end)